Lattice Grid Buy a licence

demo D131

Auto row height

Wrapped text measured per row, and the ceiling where it degrades

autoHeight: true | 'visible'

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">

<div id="grid"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 140, pin: 'start' } },
    { field: 'severity', title: 'Severity', filter: { type: 'set' }, layout: { width: 130 },
      cell: { decoration: 'pill', variant: {
        map: { critical: 'danger', major: 'warning', minor: 'info', info: 'neutral' },
      } } },
    { field: 'raised', title: 'Raised', type: 'dateString', layout: { width: 130 } },
    // wrap lets the text run onto more lines; the cell's autoHeight is what
    // measures those lines so the row grows to hold them.
    { field: 'summary', title: 'Summary', layout: { flex: 1, min: 320 },
      cell: { wrap: true, autoHeight: true } },
    { field: 'owner', title: 'Owner', filter: { type: 'set' }, layout: { width: 160 } },
  ];

  const rows = [/* incident notes with wildly uneven summary text */];

  function App() {
    // 'visible' measures only the rows on screen, so a tall summary sets its own
    // row height without walking the whole dataset first.
    return (
      <LatticeGrid
        rowKey="id"
        selection="multiple"
        autoHeight="visible"
        toolPanel={{ side: 'left', panels: ['columns', 'filters', 'views', 'quick'],
          actions: ['undo', 'redo', 'export', 'restore', 'maximise'], exportName: 'lattice-demo' }}
        columns={columns}
        rows={rows}
        style={{ height: '540px' }}
      />
    );
  }

  createRoot(document.getElementById('grid')).render(<App />);
</script>

Auto row height for wrapped text in a JavaScript data grid

Auto row height lets a row grow to fit content that would otherwise be clipped, most often a text column carrying a sentence or a paragraph rather than a short label. Reach for it when a dataset mixes free-text fields, such as notes or descriptions, with the usual short values, and a fixed row height would truncate the long ones. The option is autoHeight, set to true to measure every row up front or to 'visible' to measure only rows as they enter the viewport under virtual scrolling, which keeps the initial layout pass proportional to what is on screen rather than to the full row count.

Each row’s height comes from measuring its wrapped content against the column widths in play, so a resize or a column width change that alters wrapping is followed by a re-measure. This costs more than a fixed row height, because the grid cannot assume a uniform height when it works out which rows fall in the current scroll window, and the demo shows the ceiling: past a certain row count, per-row measurement in 'visible' mode still holds up, but true mode’s up-front pass adds a measurable delay before first paint. Assistive technology reads the resulting row as one unit regardless of how many lines it wraps to, so aria-rowindex stays correct even as heights vary row to row.

Does auto row height work with virtual scrolling in a JavaScript data grid?

Yes. Setting autoHeight: 'visible' measures each row’s wrapped height only as it scrolls into view, so the grid does not pay for measuring off-screen rows. autoHeight: true measures every row up front instead, which is simpler to reason about but scales with the full row count rather than the viewport.

Lattice Grid Buy a licence

demo D131

Auto row height

Wrapped text measured per row, and the ceiling where it degrades

autoHeight: true | 'visible'

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 140, pin: 'start' } },
  { field: 'severity', title: 'Severity', filter: { type: 'set' }, layout: { width: 130 },
    cell: { decoration: 'pill', variant: {
      map: { critical: 'danger', major: 'warning', minor: 'info', info: 'neutral' },
    } } },
  { field: 'raised', title: 'Raised', type: 'dateString', layout: { width: 130 } },
  // wrap lets the text run onto more lines; the cell's autoHeight is what
  // measures those lines so the row grows to hold them.
  { field: 'summary', title: 'Summary', layout: { flex: 1, min: 320 },
    cell: { wrap: true, autoHeight: true } },
  { field: 'owner', title: 'Owner', filter: { type: 'set' }, layout: { width: 160 } },
];

const rows = [/* incident notes with wildly uneven summary text */];



@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  grid = {
    rowKey: 'id',
    selection: 'multiple',
    autoHeight: 'visible',
    toolPanel: { side: 'left', panels: ['columns', 'filters', 'views', 'quick'],
          actions: ['undo', 'redo', 'export', 'restore', 'maximise'], exportName: 'lattice-demo' },
    columns: columns,
    rows: rows,
  };
}

bootstrapApplication(AppComponent);

Auto row height for wrapped text in a JavaScript data grid

Auto row height lets a row grow to fit content that would otherwise be clipped, most often a text column carrying a sentence or a paragraph rather than a short label. Reach for it when a dataset mixes free-text fields, such as notes or descriptions, with the usual short values, and a fixed row height would truncate the long ones. The option is autoHeight, set to true to measure every row up front or to 'visible' to measure only rows as they enter the viewport under virtual scrolling, which keeps the initial layout pass proportional to what is on screen rather than to the full row count.

Each row’s height comes from measuring its wrapped content against the column widths in play, so a resize or a column width change that alters wrapping is followed by a re-measure. This costs more than a fixed row height, because the grid cannot assume a uniform height when it works out which rows fall in the current scroll window, and the demo shows the ceiling: past a certain row count, per-row measurement in 'visible' mode still holds up, but true mode’s up-front pass adds a measurable delay before first paint. Assistive technology reads the resulting row as one unit regardless of how many lines it wraps to, so aria-rowindex stays correct even as heights vary row to row.

Does auto row height work with virtual scrolling in a JavaScript data grid?

Yes. Setting autoHeight: 'visible' measures each row’s wrapped height only as it scrolls into view, so the grid does not pay for measuring off-screen rows. autoHeight: true measures every row up front instead, which is simpler to reason about but scales with the full row count rather than the viewport.